/*
 * $Id: colormap.cpp,v 1.3 2001/06/15 07:42:54 inou Exp $
 */

#include "colormap.h"
#include "config.h"

#include <qcolor.h>

#include <fstream.h>
#include <iostream.h>

ColorMap::ColorMap()
{
  open(DEFAULT_COLORMAP);
  //for ( int i=0; i<NUM; i++ )
  //color[i]= QColor(NUM-1, i*2%NUM, i*2%NUM);
}

ColorMap::ColorMap(int r[NUM], int g[NUM], int b[NUM])
{
  for ( int i=0; i<NUM; i++ )
    color[i]= QColor(r[i], g[i], b[i]);
}

ColorMap::ColorMap(int c[NUM][3])
{
  for ( int i=0; i<NUM; i++ )
    color[i]= QColor(c[i][0], c[i][1], c[i][2]);
}

ColorMap::ColorMap(QColor c[NUM])
{
  for ( int i=0; i<NUM; i++ )
    color[i]= c[i];
}

ColorMap::ColorMap(const char *filename)
{
  open(filename);
}

ColorMap::ColorMap(const ColorMap& c)
{
  for (int i=0; i<NUM; i++)
	color[i]=c.color[i];
}

void ColorMap::open(const char *filename)
{
  ifstream input;

  char* tmp;
  if ((*filename != '/') && (*filename != '.')) {
    tmp = new char[strlen(COLORMAP_PATH)+strlen(filename)+2];
    strcpy(tmp, COLORMAP_PATH);
    strcat(tmp, "/");
    strcat(tmp, filename);
  }
  else {
    tmp = new char[strlen(filename)+1];
    strcpy(tmp, filename);
  }

  input.open(tmp);
  if (!input) {
    cerr << "cannot open colormap " << filename << ".";
    return;
  }

  int r, g, b;
  for (int i=0; i<NUM; i++) {
    input >> r >> g >> b;
    color[i]= QColor(r,g,b);
  }
}
