/*
 * $Id: plugin.cpp,v 1.2 2001/06/15 07:42:54 inou Exp $
 */

#include "plugin.h"
#include "config.h"

#include <string.h>
#include <dlfcn.h>
#include <qmessagebox.h>

Plugin::Plugin(const char *filename)
{
  open(filename);
}

Plugin::~Plugin()
{
  close();
}

void* Plugin::open(const char *filename)
{
  if ((filename==NULL) || (*filename == '\0')) return NULL;
  
  PluginInfo* (*d)(void);

  char* tmp;
  if ((*filename != '/') && (*filename != '.')) {
    tmp = new char[strlen(PLUGIN_PATH)+strlen(filename)+2];
    strcpy(tmp, PLUGIN_PATH);
    strcat(tmp, "/");
    strcat(tmp, filename);
  }
  else {
    tmp = new char[strlen(filename)+1];
    strcpy(tmp, filename);
  }
    
  if ( ( handle = dlopen(tmp, RTLD_LAZY) ) == NULL ) {
    QMessageBox::critical( 0, "Error", 
			   QString("plugin: dlopen: ") + tmp + "\n");
    return 0;
  }

  if ( ( d = (PluginInfo* (*)(void)) dlsym(handle, "getInfo__Fv") ) == NULL ) {
    QMessageBox::critical( 0, "Error", 
			   QString("dlsym: ")+
			   filename + ": getInfo\n");
    return 0;
  }
  info=d();
  
  if ( ( map = (Point (*)(Point, Point, double*)) dlsym(handle, "map__FG5PointT0Pd") ) == NULL ) {
    QMessageBox::critical( 0, "Error", 
			   "plugin: dlsym: map\n");
    return 0;
  }

  if ( ( iter = (int (*)(Point, double*, int)) dlsym(handle, "iter__FG5PointPdi") ) == NULL ) {
    QMessageBox::critical( 0, "Error", 
			   "plugin: dlsym: iter\n");
    return 0;
  }
  
  if ( ( init = (Point (*)(Point, double*)) dlsym(handle, "init__FG5PointPd") ) == NULL ) {
    QMessageBox::critical( 0, "Error", 
			   "plugin: dlsym: init\n");
    return 0;
  }
  return handle;
}

int Plugin::close()
{
 return dlclose(handle);
}
