/*
 * $Id: cubicrealjulia.cpp,v 1.2 2001/07/23 06:47:56 inou Exp $
 * z -> z^3 - 3 a^2 z + b (dynamical space with a and b real)
 */

#include "../plugin.h"
#include "math.h"

#define RE2IM2   re2=re*re; \
                 im2=im*im;

#define INIT     register double bre, bim; \
                 if (B>=0) { \
		   bre=sqrt(B); bim=0; \
                 } else { \
		   bre=0; bim=sqrt(-B); \
                 }

#define FUNCTION tmp1 = re2-im2 - 3*A; \
                 tmp2 = 2*re*im; \
		 tmp3 = tmp1*re - tmp2*im + bre; \
		 im = tmp1*im + tmp2*re + bim; \
		 re = tmp3;

#define INCOND  ( (re2+im2)<10 )

#define NAME "Cubic (real, Julia set)"
#define CHILD ""

const double XL = -2.0;
const double YT = 2.0;
const double XR = 2.0;
const double YB = -2.0;
const double CRE = 0.0;
const double CIM = 1.0;

const int MAXITER = 100;
const int MAXORBIT = 10;
const int PN = 2;
const double PARAM[2] = {0.0, 0.0};

int iter(Point z, double *param, int max)
{
  register double re=z.x;
  register double im=z.y;
  register double A=*param++;
  register double B=*param;
  register double re2=re*re;
  register double im2=im*im;
  register double tmp1,tmp2,tmp3;

  INIT

  register int i;
  for ( i=0; (i<max) && INCOND; i++ ) {
    FUNCTION
    RE2IM2
  }

  if (i>=max)
    return -1;
  else 
    return i*2;
}

Point map(Point z, Point c, double *param)
{
  register double re=z.x;
  register double im=z.y;
  register double A=*param++;
  register double B=*param;
  register double re2=re*re;
  register double im2=im*im;
  register double tmp1,tmp2,tmp3;

  INIT

  FUNCTION

  return Point(re,im);
}

Point init(Point c, double *param) {return c;}

PluginInfo* getInfo()
{
  PluginInfo* i= new PluginInfo( NAME, XL, YT, XR, YB, MAXITER, MAXORBIT,
				 PN, PARAM, CHILD);
  return i;
}
