/*
 * $Id: quadray.cpp,v 1.3 2001/06/15 07:43:00 inou Exp $
 * Mandelbrot set with external rays
 */

#include "../plugin.h"

#define RE2IM2   re2=re*re; \
                 im2=im*im;

#define FUNCTION im = 2*re*im + cim; \
                 re = re2-im2 + cre;

#define INCOND  ( (re2+im2)<100 )

#define NAME "Quadratic Family (with rays)"
//const char* NAME = "Quadratic Family (with rays)";
#define CHILD "quadrayjulia.so"
//const char* CHILD="quadrayjulia.so";

const double XL = -2.5;
const double YT = 2.0;
const double XR = 1.5;
const double YB = -2.0;
const double CRE = 0.0;
const double CIM = 1.0;

const int MAXITER = 100;
const int MAXORBIT = 10;
const int PN = 0;
const double* PARAM = (double *) 0;

int iter(Point z, double *param, int max)
{
  register double re=z.x;
  register double im=z.y;
  register double cre=re;
  register double cim=im;
  register double re2=re*re;
  register double im2=im*im;

  register int i;
  for ( i=0; (i<max) && INCOND; i++ ) {
    FUNCTION
    RE2IM2
  }

  if (i<max) {
    if ( im < 0 )
      return i*3+11;
    return i*3;
  }
  else
    return -1;
}

Point map(Point z, Point c, double *param)
{
  register double re=z.x;
  register double im=z.y;
  register double cre=c.x;
  register double cim=c.y;
  register double re2=re*re;
  register double im2=im*im;

  FUNCTION

  return Point(re,im);
}

Point init(Point c, double *param) {return c;}

PluginInfo* getInfo()
{
  PluginInfo* i= new PluginInfo( NAME, XL, YT, XR, YB, MAXITER, MAXORBIT,
				 PN, PARAM, CHILD);
  return i;
}
