/*
 * $Id: quadrayper3julia.cpp,v 1.2 2001/07/23 06:47:56 inou Exp $
 * quadratic map with period 3 external rays
 */

#include "../plugin.h"
#include <cmath>

#define RE2IM2   re2=re*re; \
                 im2=im*im;

#define FUNCTION im = 2*re*im + cim; \
                 re = re2-im2 + cre;

#define INCOND  ( (re2+im2)<100 )

#define NAME "Quadratic Map (with period 3 rays)"
#define CHILD ""

const double XL = -2.0;
const double YT = 2.0;
const double XR = 2.0;
const double YB = -2.0;

const int MAXITER = 50;
const int MAXORBIT = 10;
const int PN = 2;
const double PARAM[2] = {-.122561166876653619975245551820,
                          .744861766619744236593170428604};

const double slope1=tan(2*M_PI*1/7);
const double slope2=tan(2*M_PI*2/7);
const double slope3=tan(2*M_PI*4/7);

int iter(Point z, double *param, int max)
{
  register double re=z.x;
  register double im=z.y;
  register double cre=*param++;
  register double cim=*param;
  register double re2=re*re;
  register double im2=im*im;

  register int i;
  for ( i=0; (i<max) && INCOND; i++ ) {
    FUNCTION
    RE2IM2
  }

  if (i<max) {
    if ( (slope1*re < im) && (slope2*re < im) )
      return i*5;
    if ( (slope2*re > im) && (slope3*re < im) )
      return i*5+1;
    return i*5+2;
  }
  else
    return -1;
}

Point map(Point z, Point c, double *param)
{
  register double re=z.x;
  register double im=z.y;
  register double cre=*param++;
  register double cim=*param;
  register double re2=re*re;
  register double im2=im*im;

  FUNCTION

  return Point(re,im);
}

Point init(Point c, double *param) {return c;}

PluginInfo* getInfo()
{
  PluginInfo* i= new PluginInfo(NAME, XL, YT, XR, YB, MAXITER, MAXORBIT,
				PN, PARAM, CHILD);
  return i;
}
