/*
 * $Id: window.h,v 1.4 2001/07/23 06:49:07 inou Exp $
 */

#ifndef WINDOW_H
#define WINDOW_H

#include <qmainwindow.h>
#include "pixmap.h"
#include "plugin.h"
#include "canvas.h"

class QWidget;
class QResizeEvent;
class QAction;

class Point;
class ColorMap;

class MainWindow: public QMainWindow
{
  Q_OBJECT
public:
  MainWindow();

  void setParamNum( int n );
  void setParam( double *p )
  { for ( int i=0; i<paramnum; i++ ) param[i]=p[i]; canvas->setParam(p); }

  void setMaxIter( int m ) { maxiter=m;canvas->setMaxIter(m); }
  void setMaxOrbit( int m ) { maxorbit=m;canvas->setMaxOrbit(m); }

  int paramNum() { return paramnum; }
  double getParam(int i) { if (i<paramnum) return param[i]; else return 0; }
  // checking i<paramnum is unnecessary?

  void setFunc( Point (*f)(Point, Point, double* ) )
  { canvas->setFunc(f); }
  void setInitFunc( Point (*f)(Point, double* ) )
  { canvas->setInitFunc(f); }
  void setIterFunc( int (*f)(Point, double*, int ) )
  { canvas->setIterFunc(f); }
  void loadPlugin(const char *filename);
  void setRegion(Rect r) { canvas->setRegion( r ); }

public slots:
  void draw() { canvas->draw(); }
  void newWindow();
  void setParam();
  void toggleOrbit();
  void createChild();
  void loadPlugin();
  void revertPlugin() { canvas->setPlugin( plugin ); draw(); }
  void loadColorMap();
  void setColorMap( ColorMap c ) { canvas->setColorMap(c); }
  void orbitChanged();
  void paramChanged();
  void receiveParam( Point, int, double* );
  void childClosed() { child=NULL; }
  void disconnectChild();

signals:
  void orbitChanged( bool );
  void pluginChanged();

protected:
  Canvas* canvas;

  int paramnum;
  double *param;

  int maxiter;
  int maxorbit;

  Plugin *plugin;

  QAction *actionSetParam;
  QAction *actionSetChild;

  int SetOrbitId;
  bool isOrbit;

  MainWindow* child;
};

#endif // WINDOW_H
